#include "tensor.h"
#include <iomanip>
#include "cputime.h"

Real ran1();

void Reshape2(const Tensor& x, Permutation p, Tensor& res)
    {
    res.dat.ReDimension(x.dat.Length());
    res.d = x.d;
    for(int m = 1; m <= 8; m++)
	res.n[p.ind[m]] = x.n[m];
    int bigind = 1, big = x.n[1];
    for(int m = 2; m <= 8; m++)
	if(big < x.n[m])
	    big = x.n[m], bigind = m;
    int rbigind = p.ind[bigind];
    int jj[9];
    for(int m = 1; m <= 8; m++)
	jj[m] = 1;
    jj[bigind] = 2;
    int stepx = x.ind(jj[1],jj[2],jj[3],jj[4],jj[5],jj[6],jj[7],jj[8]) - 1;
    jj[bigind] = 1;
    jj[rbigind] = 2;
    int stepr = res.ind(jj[1],jj[2],jj[3],jj[4],jj[5],jj[6],jj[7],jj[8]) - 1;

    int *j[9];
    Counter c(x);
    for(int m = 1; m <= 8; m++)
	j[p.ind[m]] = &(c.i[m]);
    for( ; c != Counter::done ; ++c)
	if(c.i[bigind] == 1)
	    {
	    int rstart = res.ind(*j[1],*j[2],*j[3],*j[4],*j[5],*j[6],*j[7],*j[8]);
	    int xstart = x.ind(c.i[1],c.i[2],c.i[3],c.i[4],c.i[5],c.i[6],c.i[7],c.i[8]);
	    for(int k = 0; k < big; k++)
		res.dat(rstart+k*stepr) = x.dat(xstart+k*stepx);
	    }
    }
#define NEWreshape
void Reshape(const Tensor& x, Permutation p, Tensor& res)
    {
#ifdef NEWreshape
    Reshape2(x,p,res);
    return;
#endif
    res.dat.ReDimension(x.dat.Length());
    res.d = x.d;
    int *j[9];
    Counter c(x);
    for(int m = 1; m <= 8; m++)
	j[p.ind[m]] = &(c.i[m]);
    for(int m = 1; m <= 8; m++)
	res.n[p.ind[m]] = x.n[m];
    for( ; c != Counter::done ; ++c)
	{
	res(*j[1],*j[2],*j[3],*j[4],*j[5],*j[6],*j[7],*j[8]) = c.val(x);
//	    x(c.i[1],c.i[2],c.i[3],c.i[4],c.i[5],c.i[6],c.i[7],c.i[8]);
	}
    }

void Product(const Tensor& x, const Tensor& y, Tensor& res)
    {
    if(x.d+y.d > 8) 
	{
	cout << x << y;
	error("bad contraction size Product 798234892");
	}
    Counter xc(x), yc(y);
    int *j[9];
    for(int m = 1; m <= 8; m++)
	j[m] = &(xc.i[m]), res.n[m] = xc.n[m];
    for(int m = 1; m <= y.d; m++)
	j[m+x.d] = &(yc.i[m]), res.n[m+x.d] = yc.n[m];
    res.d = x.d+y.d;
    int pr = 1;
    for(int i = 1; i <= res.d; i++)
	pr *= res.n[i];
    res.dat.ReDimension(pr);

    for(; xc != Counter::done; ++xc)
	{
	//Real *px = &(x(xc.i[1],xc.i[2],xc.i[3],xc.i[4], xc.i[5],xc.i[6],xc.i[7]));
	Real xval = x(xc.i[1],xc.i[2],xc.i[3],xc.i[4],xc.i[5],xc.i[6],xc.i[7]);
	for(yc.init(1); yc != Counter::done; ++yc)
	    {
	    //Real *py = &(y(yc.i[1],yc.i[2],yc.i[3],yc.i[4], yc.i[5],yc.i[6],yc.i[7]));
	    //Real r = xval * y(yc.i[1],yc.i[2],yc.i[3],yc.i[4],yc.i[5],yc.i[6],yc.i[7]);

	    res(*j[1],*j[2],*j[3],*j[4],*j[5],*j[6],*j[7],*j[8]) = xval *
		    y(yc.i[1],yc.i[2],yc.i[3],yc.i[4],yc.i[5],yc.i[6],yc.i[7]);
	    }
	}
    }

ostream & operator << (ostream & s, const Tensor & t)
    {
    if(t.n[1] == 1 && t.n[2] == 1 && t.n[3] == 1 && t.n[4] == 1)
	return s << t(1) << endl;
    Counter c(t);
    for(; c != Counter::done; ++c)
	{
	if(t.dat(c.ind) != 0.0)
	    {
	    for(int i = 1; i <= t.d; i++)
		cout << c.i[i] << " ";
	    s << t.dat(c.ind) << endl;
	    }
	}
    return s;
    }
ostream & operator << (ostream & s, const ITensor & t)
    {
    s << "logfac(inc in els) = " << t.logfac << ", d = " << t.d << ": ";
    for(int i = 1; i <= t.d; i++)
	{
	s << t.index(i) << "=" << t.n[i]; 
	if(i != t.d) s << ", ";
	}
    s << "(" << t.dat.Length() << "," << Norm(t.dat) << ")";
    if(printdat)
	{
	Tensor tt(t);
	tt.dat *= exp(t.logfac);
	s << endl << tt;
	}
    else
	s << endl;
    //if(printdat) s << t.dat;
    return s;
    }

void Reshape(const ITensor& x, Permutation p, ITensor& res)
    {
    res.dat.ReDimension(x.dat.Length());
    res.d = x.d;
    res.logfac = x.logfac;
    int *j[9];
    Counter c(x);
    for(int m = 1; m <= 8; m++)
	j[p.ind[m]] = &(c.i[m]);
    for(int m = 1; m <= 8; m++)
	//res.n[p.ind[m]] = x.n[m], res.index(p.ind[m]) = x.index(m);
	res.n[p.ind[m]] = x.n[m], res.set_index(p.ind[m],x.index(m));

    res.set_unique_Real();
    int firstdif = 100;
    for(int m = 1; m <= 8; m++)
	if(p.ind[m] != m)
	    {
	    firstdif = m;
	    break;
	    }
    if(firstdif == 100)
	{
	res.dat = x.dat;
	return;
	}

#define loop5(a,b,c,d,e) {for(int i1 = 1; i1 <= x.n[1]; i1++) for(int i2 = 1; i2 <= x.n[2]; i2++)\
	for(int i3 = 1; i3 <= x.n[3]; i3++) for(int i4 = 1; i4 <= x.n[4]; i4++)\
	for(int i5 = 1; i5 <= x.n[5]; i5++) res.val5(a,b,c,d,e) = x(i1,i2,i3,i4,i5); return; }

#define loop4(a,b,c,d) {for(int i1 = 1; i1 <= x.n[1]; i1++)  for(int i2 = 1; i2 <= x.n[2]; i2++)\
	for(int i3 = 1; i3 <= x.n[3]; i3++) for(int i4 = 1; i4 <= x.n[4]; i4++)\
	res.val4(a,b,c,d) = x(i1,i2,i3,i4); return; }

#define loop3(a,b,c) {for(int i1 = 1; i1 <= x.n[1]; i1++)  for(int i2 = 1; i2 <= x.n[2]; i2++)\
	for(int i3 = 1; i3 <= x.n[3]; i3++) res.val3(a,b,c) = x(i1,i2,i3); return; }

#define bif3(a,b,c) if(p.ind[1] == a && p.ind[2] == b && p.ind[3] == c)

#define bif4(a,b,c,d) if(p.ind[1] == a && p.ind[2] == b && p.ind[3] == c && p.ind[4] == d)

#define bif5(a,b,c,d,e) if(p.ind[1] == a && p.ind[2] == b && p.ind[3] == c && p.ind[4]==d && p.ind[5] == e)

    if(x.d == 2 && p.ind[1] == 2 && p.ind[2] == 1)
	{
	for(int i1 = 1; i1 <= x.n[1]; i1++)  
	    for(int i2 = 1; i2 <= x.n[2]; i2++)\
	         res(i2,i1) = x(i1,i2); 
	return; 
	}


    if(x.d == 3)
	{
	bif3(2,3,1) loop3(i3,i1,i2)
	bif3(3,2,1) loop3(i3,i2,i1)
	bif3(1,3,2) loop3(i1,i3,i2)
	bif3(2,1,3) loop3(i2,i1,i3)
	bif3(3,1,2) loop3(i2,i3,i1)
	}

    if(x.d == 4)
	{
	bif4(3,2,4,1) loop4(i4,i2,i1,i3)
	bif4(2,3,1,4) loop4(i3,i1,i2,i4)
	bif4(3,1,4,2) loop4(i2,i4,i1,i3)
	bif4(2,1,3,4) loop4(i2,i1,i3,i4)
	bif4(1,3,2,4) loop4(i1,i3,i2,i4)
	bif4(4,3,1,2) loop4(i3,i4,i2,i1)
	bif4(1,3,4,2) loop4(i1,i4,i2,i3)
	}
    if(x.d == 5)
	{
	bif5(2,3,4,5,1) loop5(i5,i1,i2,i3,i4)
	bif5(2,3,4,1,5) loop5(i4,i1,i2,i3,i5)
	bif5(3,4,1,5,2) loop5(i3,i5,i1,i2,i4)
	bif5(3,1,4,5,2) loop5(i2,i5,i1,i3,i4)
	bif5(5,1,4,2,3) loop5(i2,i4,i5,i3,i1)
	}

    if(0)cout << "permutation is " << x.d SP p << endl;

    for( ; c != Counter::done ; ++c)
	res(*j[1],*j[2],*j[3],*j[4],*j[5],*j[6],*j[7],*j[8]) = c.val(x);
    }

static bool dononcontract = false;
ITensor ITensor::operator/(const ITensor& other) const
    {
    dononcontract = true;
    ITensor res = (*this) * other;
    dononcontract = false;
    return res;
    }

// Cjik = Aij Bkj
void noncontractprod(MatrixRef& xref,MatrixRef& yref,Vector& res)
    {
    int ni = xref.Nrows(), nj = xref.Ncols(), nk = yref.Nrows();
    Matrix xx(xref), yy(yref);
    res.ReDimension(ni*nj*nk);
    res = 0.0;
    for(int j = 1; j <= nj; j++)
	for(int k = 1; k <= nk; k++)
	    for(int i = 1; i <= ni; i++)
		res(((k-1)*ni+i-1)*nj+j) = xx(i,j) * yy(k,j); 
    }

ITensor ITensor::operator*(const ITensor& other) const
    {
    ITensor res;
    product(other,res);
    return res;
    }
void ITensor::product(const ITensor& other, ITensor& res) const
    {
    // Complex types are treated as just another index, of type ReIm
    // Multiplication is handled automatically with these simple tensor helpers
    if(findindex(IndReIm) && other.findindex(IndReIm) && !other.findindex(IndReImP)
	    && !other.findindex(IndReImPP))
	{
	static ITensor primer(IndReIm,IndReImP,1.0);
	static ITensor primerP(IndReIm,IndReImPP,1.0);
	static ITensor prod(IndReIm,IndReImP,IndReImPP);
	static int first = 1;
	if(first)
	    {
	    IV iv0(IndReIm,1), iv1(IndReImP,1), iv2(IndReImPP,1);
	    iv0.i = 1; iv1.i = 1; iv2.i = 1; prod.val(iv0,iv1,iv2) = 1.0;
	    iv0.i = 1; iv1.i = 2; iv2.i = 2; prod.val(iv0,iv1,iv2) = -1.0;
	    iv0.i = 2; iv1.i = 2; iv2.i = 1; prod.val(iv0,iv1,iv2) = 1.0;
	    iv0.i = 2; iv1.i = 1; iv2.i = 2; prod.val(iv0,iv1,iv2) = 1.0;
	    first = 0;
	    }
	res = (*this * primer) * prod * (other * primerP);
	return;
	}
    int numsame = 0, left[9],right[9],contracted_left[9],contracted_right[9];
    for(int j = 1; j <= 8; j++)
	contracted_left[j] = 0, contracted_right[j] = 0;
    for(int j = 1; j <= d; j++)
	for(int k = 1; k <= other.d; k++)
	    if(index(j) == other.index(k))
		{
		if(n[j] != other.n[k]) { cout << *this << endl << other << endl; cout << j SP n[j] SP other.n[k] << endl; error("bad match of index sizes"); }
		left[numsame] = j;
		right[numsame++] = k;
		contracted_left[j] = contracted_right[k] = 1;
		if(0)cout << "same, j,k are " << j SP k SP left[numsame-1] SP right[numsame-1] << endl; if(0)cout << index(j) SP other.index(k) SP n[j] SP other.n[k] << endl;
		}
    if(dononcontract)
	res.d = d + other.d - numsame;
    else
	res.d = d + other.d - 2 * numsame;
    if(res.d > maxdim) { cout << *this << endl << other << endl; cout << "dononcontract = " << dononcontract << endl; error("res.d too big in product 723948723"); }
    if(numsame == 0)
	{
	Product((const Tensor&)(*this),(const Tensor&)(other),(Tensor&) res);
	for(int m = 1; m <= 8; m++)
	    res.set_index(m,index(m));
	for(int m = 1; m <= other.d; m++)
	    res.set_index(m+d,other.index(m));
	res.logfac = logfac + other.logfac;
	res.donormlog();
	res.set_unique_Real();
	return;
	}
    Permutation px, py;
    int dimleft = 1, dimright = 1;	// dimensions of contracted inds
    for(int j = 0; j < numsame; j++)
	{
	px.ind[left[j]] = j+1;
	dimleft *= n[left[j]];
	py.ind[right[j]] = j+1;
	dimright *= other.n[right[j]];
	}
    int ii = numsame+1;
    for(int i = 1; i <= d; i++)
	if(!contracted_left[i])
	    px.ind[i] = ii++;
    ii = numsame+1;
    for(int i = 1; i <= other.d; i++)
	if(!contracted_right[i])
	    py.ind[i] = ii++;
    ITensor xs,ys;
    Reshape(*this,px,xs);
    Reshape(other,py,ys);
    int resind = 1;
    if(dononcontract)
	for(int i = 1; i <= numsame; i++)
	    res.set_index(resind,xs.index(i)),
	    res.n[resind++] = xs.n[i];
    for(int i = numsame+1; i <= xs.d; i++)
	res.set_index(resind,xs.index(i)),
	res.n[resind++] = xs.n[i];
    for(int i = numsame+1; i <= ys.d; i++)
	res.set_index(resind,ys.index(i)),
	res.n[resind++] = ys.n[i];

    int odimleft = dat.Length()/dimleft;
    int odimright = other.dat.Length()/dimright;
    MatrixRef xref,yref;
    xs.dat.TreatAsMatrix(xref,odimleft,dimleft);
    ys.dat.TreatAsMatrix(yref,odimright,dimright);
    if(dononcontract)
	{
	noncontractprod(xref,yref,res.dat);
	}
    else
	{
	if(writeops && yref.Nrows() * yref.Ncols() * xref.Nrows() > 100000000)
	    {
	    bool p = printdat;
	    printdat = false;
	    big_op_file << "mult: " << yref.Nrows() * yref.Ncols() * xref.Nrows() << "	";
	    for(int i = 1; i <= this->d; i++)
		big_op_file << index(i) << " ";
	    big_op_file << " * ";
	    for(int i = 1; i <= other.d; i++)
		big_op_file << other.index(i) << " ";
	    big_op_file << endl;
	    printdat = p;
	    }
	//cpu_time cpu;
	Matrix resmat = yref * xref.t();
	//if(writeops && yref.Nrows() * yref.Ncols() * xref.Nrows() > 100000000)
	    //big_op_file << "	" << cpu.sincemark() << endl;
	res.dat.ReDimension(resmat.Nrows()*resmat.Ncols());
	res.dat = resmat.TreatAsVector();
	}
    res.logfac = logfac + other.logfac;
    res.donormlog();
    res.set_unique_Real();
    return;
    }

Permutation getpermBtoA(const ITensor& A, const ITensor& B)
    {
    if(B.d != A.d)
	{
	cout << A.d SP B.d << endl;
	cout << A SP B << endl;
	error("getpermBtoA: ds not same");
	}
    Permutation P;
    for(int j = 1; j <= B.d; j++)
	{
	int gotone = 0;
	for(int k = 1; k <= A.d; k++)
	    if(B.index(j) == A.index(k))
		{
		P.ind[j] = k;
		gotone++;
		}
	if(gotone != 1)
	    {
	    cout << j << endl;
	    cout << A << endl;
	    cout << B << endl;
	    error("getpermBtoA: gotone != 1");
	    }
	}
    return P;
    }
void ITensor::Assign(const ITensor& other)
    {
    Permutation P = getpermBtoA(*this,other);
    Reshape(other,P,*this);
    }
ITensor& ITensor::operator+=(const ITensor& other)
    {
    ITensor& This(*this);
    bool complex_this = findindex(IndReIm); 
    bool complex_other = other.findindex(IndReIm); 
    if(!complex_this && complex_other)
	return (This = (This * Complex_1) + other);
    if(complex_this && !complex_other)
	return (This += other * Complex_1);

    Permutation p = getpermBtoA(This,other);
    int *j[9];
    Counter c(other);
    for(int m = 1; m <= 8; m++)
	j[p.ind[m]] = &(c.i[m]);
    Real dlogfac = other.logfac - logfac;
    if(dlogfac < -200.0)		// no effect from other
	return *this;
    if(dlogfac < 0.0)	
	{
	Real f = exp(dlogfac);
	for( ; c != Counter::done ; ++c)
	    This(*j[1],*j[2],*j[3],*j[4],*j[5],*j[6],*j[7],*j[8]) += f * c.val(other);
	return *this;
	}
    if(dlogfac > 200.0)
	for( ; c != Counter::done ; ++c)
	    This(*j[1],*j[2],*j[3],*j[4],*j[5],*j[6],*j[7],*j[8]) = c.val(other);
    else
	{
	dat *= exp(-dlogfac);
	for( ; c != Counter::done ; ++c)
	    This(*j[1],*j[2],*j[3],*j[4],*j[5],*j[6],*j[7],*j[8]) += c.val(other);
	}
    logfac = other.logfac;
    return *this;
    } 

// group i1,i2; i3,i4
void ITensor::getMatrix22(Index i1, Index i2, Index i3, Index i4,Matrix& res) const	// doesn't put in logfac
    {
    if(d != 4) error("dnot4 e72349823");
    ITensor Q(i3,i4,i1,i2);
    Q.Assign(*this);
    int nrow = Q.n[3] * Q.n[4], ncol = Q.n[1] * Q.n[2];
    res.ReDimension(nrow,ncol);
    res.TreatAsVector() = Q.dat;
    }
void ITensor::fromMatrix22(Index i1, Index i2, Index i3, Index i4,const Matrix& res)	// doesn't put in logfac
    {
    if(d != 4) error("dnot4 e72349823");
    if(nindex(i1) == 0) error("nindexi1 3249");
    if(nindex(i2) == 0) error("nindexi2 3249");
    if(nindex(i3) == 0) error("nindexi3 3249");
    if(nindex(i4) == 0) error("nindexi4 3249");
    ITensor Q(i3,i4,i1,i2);
    if(Q.n[1]*Q.n[2] != res.Ncols()) error("Q12 nrows 32749832");
    if(Q.n[3]*Q.n[4] != res.Nrows()) error("Q34 ncols 0983120");
    Q.dat = res.TreatAsVector();
    Assign(Q);
    }
ITensor Inverse(const ITensor& Q,Index i1, Index i2, Index i3, Index i4) // group i1,i2; i3,i4
    {
    Matrix Qmat;
    Q.getMatrix22(i1,i2,i3,i4,Qmat);
    Matrix Qimat(Inverse(Qmat));
    if(0)
	{
	Matrix U,V;
	Vector d;
	SVD(Qmat,U,d,V);
	cout << "Singular values of matrix to be inverted are " << endl << d;
	}
    ITensor res(Q);
    res.fromMatrix22(i1,i2,i3,i4,Qimat);
    res.logfac = -Q.logfac;
    return res;
    }
void ITensor::getMatrix11(Index i1, Index i2, Matrix& res) const	// doesn't put in logfac
    {
    if(d != 2) 
	{
	cout << *this;
	error("d is not 2 821732");
	}

    int n1 = nindex(i1), n2 = nindex(i2);
    res.ReDimension(n1,n2);
    if(i1 == index(2))
	res.TreatAsVector() = dat;
    else
	{
	ITensor Q(i2,i1);
	Q.Assign(*this);
	res.TreatAsVector() = Q.dat;
	}
    }
void ITensor::fromMatrix11(Index i1, Index i2, const Matrix& res)	// doesn't put in logfac
    {
    if(d != 2) error("dnot2 e79823");
    if(nindex(i1) != res.Nrows()) error("fm11 8784732");
    if(nindex(i2) != res.Ncols())
	{
	cout << i1 SP i2 SP res.Nrows() SP res.Ncols() << endl;
	cout << *this << endl;
	error("fm11 782932");
	}
    if(i1.m() != res.Nrows())
	{
	cout << i1 SP i2 SP res.Nrows() SP res.Ncols() << endl;
	error("fm11 87uywe84732");
	}
    if(i2.m() != res.Ncols()) 
	{
	cout << res.Nrows() SP res.Ncols() << endl;
	cout << i2 SP i2.m() << endl;
	error("fm11 8923hjhj732");
	}
    if(i1 == index(2))
	dat = res.TreatAsVector(); 
    else
	{
	ITensor Q(i2,i1);
	Q.dat = res.TreatAsVector();
	Assign(Q);
	}
    }
void ITensor::getMatrix21(Index i1, Index i2, Index i3, Matrix& res) const	// doesn't put in logfac
    {
    if(d != 3) error("dnot3 83421732");
    int n1 = nindex(i1), n2 = nindex(i2), n3 = nindex(i3);
    ITensor Q(i3,i1,i2);
    Q.Assign(*this);
    res.ReDimension(n1*n2,n3);
    res.TreatAsVector() = Q.dat;
    }
void ITensor::getMatrix12(Index i1, Index i2, Index i3, Matrix& res) const	// doesn't put in logfac
    {
    if(d != 3) error("dnot3 27635980");
    int n1 = nindex(i1), n2 = nindex(i2), n3 = nindex(i3);
    ITensor Q(i2,i3,i1);
    Q.Assign(*this);
    res.ReDimension(n1,n2*n3);
    res.TreatAsVector() = Q.dat;
    }
void ITensor::fromMatrix21(Index i1, Index i2, Index i3, const Matrix& res)	// doesn't put in logfac
    {
    if(d != 3) error("dnot4 e72349823");
    int n1 = nindex(i1), n2 = nindex(i2), n3 = nindex(i3);
    if(n1*n2 != res.Nrows()) error("fm21 873284732");
    if(n3 != res.Ncols()) error("fm21 78293632");
    ITensor Q(i3,i1,i2);
    Q.dat = res.TreatAsVector();
    Assign(Q);
    }
void ITensor::fromMatrix12(Index i1, Index i2, Index i3, const Matrix& res)	// doesn't put in logfac
    {
    if(d != 3) error("dnot4 e738477");
    int n1 = nindex(i1), n2 = nindex(i2), n3 = nindex(i3);
    if(n1 != res.Nrows()) error("fm12 87832487");
    if(n3*n2 != res.Ncols()) error("fm12 76329095");
    ITensor Q(i2,i3,i1);
    Q.dat = res.TreatAsVector();
    Assign(Q);
    }

void IndexToFront(ITensor& A, Index i)
    {
    int f = 0;
    for(f = 1; f <= A.d; f++)
	if(A.index(f) == i) break;
    if(f == 1) return;
    if(f == A.d+1) 
	{
	cout << A << i << endl;
	error("no index found for front");
	}
    Permutation P;
    P.ind[f] = 1;
    for(int j = 1; j < f; j++)
	P.ind[j] = j+1;
    ITensor res;
    Reshape(A,P,res);
    A = res;
    }
void IndexToFront(ITensor& A, Index i, Index j)
    {
    int f = 0, g = 0;
    for(f = 1; f <= A.d; f++)
	if(A.index(f) == i) break;
    for(g = 1; g <= A.d; g++)
	if(A.index(g) == j) break;
    if(f == A.d+1 || g == A.d+1) 
	{
	cout << A << i << j << endl;
	error("no index found for front");
	}
    Permutation P;
    P.ind[f] = 1;
    P.ind[g] = 2;
    int k = 3;
    for(int n = 1; n <= A.d; n++)
	if(n != f && n != g)
	    P.ind[n] = k++;
    ITensor res;
    Reshape(A,P,res);
    A = res;
    }

void ITensor::PrimesToBack()
    {
    Permutation P;
    int b = 1, nump = 0;
    for(int j = 1; j <= d; j++)
	if(index(j).primelevel > 0)
	    nump++;
    int e = d - nump + 1;
    for(int j = 1; j <= d; j++)
	if(index(j).primelevel > 0)
	    P.ind[j] = e++;
	else
	    P.ind[j] = b++;
    ITensor B;
    Reshape(*this,P,B);
    *this = B;
    }

void ITensor::SplitReIm(ITensor& re, ITensor& im) const
    {
    ITensor cop(*this);
    if(!findindex(IndReIm))
	{
	re = cop;
	im = cop;
	im.dat *= 0.0;
	return;
	}
    Real lfac = logfac;
    cop.logfac = 0.0;
    cop.mapindex(IndReIm,IndReImP);
    ITensor repart(IndReImP), impart(IndReImP);  
    repart.dat(1) = 1.0;
    impart.dat(2) = 1.0;
    re = cop * repart;
    im = cop * impart;
    re.dat *= exp(re.logfac);
    im.dat *= exp(im.logfac);
    re.logfac = lfac;
    im.logfac = lfac;
    }

ITensor operator*(const ITensor& t, const Combiner& c)
    {
    int j;
    ITensor res;
    if((j = t.findindex(c.right())) != 0)
	{
	for(int i = 1; i < j; i++)
	    res.set_index(i,t.index(i));
	for(int i = 1; i <= c.dl; i++)
	    res.set_index(j+i-1,c.left[i]);
	for(int i = j+1; i <= t.d; i++)
	    res.set_index(i+c.dl-1,t.index(i));
	res.d = t.d + c.dl - 1;
	for(int i = 1; i <= res.d; i++)
	    res.n[i] = res.index(i).m();
	res.dat = t.dat;
	res.logfac = t.logfac;
	res.set_unique_Real();
	return res;
	}
    Permutation P;
    for(int i = 1; i <= c.dl; i++)
	if((j = t.findindex(c.left[i])) == 0)
	    {
	    cout << t << endl;
	    cout << c << endl;
	    error("bad Combiner ITensor product");
	    }
	else
	    P.ind[j] = t.d - c.dl + i;
    int k = 1;
    for(int i = 1; i <= t.d; i++)
	if(c.findindex(t.index(i)) == 0)
	    P.ind[i] = k++;
    Reshape(t,P,res);
    res.d = t.d - c.dl + 1;
    res.set_index(res.d,c.right());
    res.n[res.d] = c.right().m();
    for(int i = res.d+1; i <= t.d; i++)
	res.n[i] = 1;
    res.set_unique_Real();
    return res;
    }

// Sorted, biggest to smallest
void ComplexEigenvalues(const Matrix& re, const Matrix& im, Vector& evals,
	                        Matrix& revecs, Matrix& ievecs)
{
    int n = re.Nrows();
    Matrix big(2*n,2*n), evecs;
    big.SubMatrix(1,n,1,n) = re;
    big.SubMatrix(1,n,n+1,2*n) = -im;
    big.SubMatrix(n+1,2*n,1,n) = im;
    big.SubMatrix(n+1,2*n,n+1,2*n) = re;
    Vector v(2*n),r(2*n), eeval;
    evals.ReDimension(n);
    revecs.ReDimension(n,n);
    ievecs.ReDimension(n,n);
    big *= -1.0;
    cpu_time cpu;
    EigenValues(big,eeval,evecs);
    if(writeops && n*n*n > 1000000)
	big_op_file << "n == " << n << ", ComplexEigs took " << cpu.sincemark() << endl;
    eeval *= -1.0;
    //cout << "eeval is " << eeval << endl;
    Matrix newvs(n,2*n);
    Vector neweval(n), done(2*n);
    done = 0.0;

    for(int j = 1; j <= n; j++)
	{
	Real bignorm = 0.0, nor;
	int k = 1;
	for(int i = 1; i <= 2*n; i++)
	    if(done(i) == 0.0 && (nor = Norm(evecs.Column(i))) > bignorm)
		bignorm = nor, k = i;
	done(k) = 1.0;
	v = evecs.Column(k);
	v *= 1.0/bignorm;
	newvs.Row(j) = v;
	neweval(j) = eeval(k);
	r.SubVector(1,n) = -v.SubVector(n+1,2*n);
	r.SubVector(n+1,2*n) = v.SubVector(1,n);
	for(int i = 1; i <= 2*n; i++)
	    {
	    if(done(i) == 1.0 || fabs(eeval(i) - neweval(j)) > 1.0e-4)
		continue;
	    Real d = r * evecs.Column(i);
	    if(fabs(d) > 1.0e-10)
		evecs.Column(i) += (-d) * r;
	    d = v * evecs.Column(i);
	    if(fabs(d) > 1.0e-10)
		evecs.Column(i) += (-d) * v;
	    }
	}
    for(int j = 1; j <= n; j++)
	{
	Real bigeval = -1.0e19;
	int k = 1;
	for(int i = 1; i <= n; i++)
	    if(neweval(i) > bigeval)
		bigeval = neweval(i), k = i;
	evals(j) = neweval(k);
	neweval(k) = -1.0e20;
	revecs.Column(j) = newvs.Row(k).SubVector(1,n);
	ievecs.Column(j) = newvs.Row(k).SubVector(n+1,2*n);
	}
    if(1)
	{
	Matrix diagch = revecs.t() * re * revecs - revecs.t() * im * ievecs + ievecs.t() * im * revecs
		    + ievecs.t() * re * ievecs;
	Matrix zeroch = revecs.t() * im * revecs + revecs.t() * re * ievecs - ievecs.t() * re * revecs
		    + ievecs.t() * im * ievecs;
	Real normzero = Norm(zeroch.TreatAsVector());
	for(int j = 1; j <= n; j++)
	    diagch(j,j) -= evals(j);
	Real normzero2 = Norm(diagch.TreatAsVector());
	if(normzero + normzero2 > 1.0e-6) 
	    cout << "ComplexEigs check: " << normzero SP normzero2 << endl;
	}
}

Index index_in_common(const ITensor& A, const ITensor& B, IndexType t)
    {
    for(int k = 1; k <= A.d; k++)
	if(A.index(k).type() == t)
	    {
	    int j = B.findindex(A.index(k));
	    if(j != 0)
		return A.index(k);
	    }
    error("bad link_in_common");
    return A.index(1);
    }
